
package approximations;
/**
 * La classe <code>Couple</code> modlise un couple d'objets. La comparaison
 * de deux instance de Couple se fait selon l'ordre sur leurs premiers lments.
 * @author Yann Ponty
 */

public class Couple implements Comparable
{
  private Object _first = null;
  private Object _second = null;

  /**
   * Construit un couple d'objets  partir de 2 objets.
   * @param a Le premier objet du couple (dsormais obtenu par la mthode <code>fst</code>)
   * @param a Le second objet du couple (dsormais obtenu par la mthode <code>snd</code>)
   */

  public Couple(Object a, Object b)
  {
    super();
    _first = a;
    _second = b;
  }

  /**
   * Renvoie le premier objet du couple.
   * @return Le premier argument pass au constructeur lors de la cration de l'objet
   */
  public Object fst()
  {return _first;}

  /**
   * Renvoie le deuxime objet du couple.
   * @return Le deuxime argument pass au constructeur lors de la cration de l'objet
   */
  public Object snd()
  {return _second;}

  public void setFst(Object o)
  {_first = o;}

  public void setSnd(Object o)
  { _second = o;}

  public String toString()
  {
    return "("+_first.toString()+";"+_second.toString()+")";
  }

  public int compareTo(Object o)
  {
    Couple to = (Couple)o;
    Comparable x1 = (Comparable) _first;
    Comparable x2 = (Comparable) to.fst();
    return x1.compareTo(x2);
  }
}