
/**
 * Title:        Approximations Simulation<p>
 * Description:  Simulation sur des exemples de divers algorithmes d'approximation pour la compression de chanes de caractres utilisant des grammaires non contextuelles.<p>
 * Copyright:    Copyright (c) Ccile Malinaud/Yann Ponty<p>
 * Company:      <p>
 * @author Ccile Malinaud/Yann Ponty
 * @version 1.0
 */
package approximations;

import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import java.io.*;

public class SimulFrame extends JFrame {
  JPanel contentPane;
  JLabel statusBar = new JLabel();
  BorderLayout borderLayout1 = new BorderLayout();
  JToolBar jToolBar1 = new JToolBar();
  JPanel jPanel1 = new JPanel();
  JButton runButton = new JButton();
  JRadioButton simulFromFile = new JRadioButton();
  JLabel nomFichier = new JLabel();
  GridLayout gridLayout1 = new GridLayout();
  JScrollPane jScrollPane1 = new JScrollPane();
  JScrollPane jScrollPane2 = new JScrollPane();
  JScrollPane jScrollPane3 = new JScrollPane();
  JScrollPane jScrollPane4 = new JScrollPane();
  JTextArea jTextArea1 = new JTextArea();
  JTextArea jTextArea2 = new JTextArea();
  JTextArea jTextArea3 = new JTextArea();
  JTextArea jTextArea4 = new JTextArea();
  JRadioButton simulFromUser = new JRadioButton();
  JTextField userInput = new JTextField();
  JButton openFileButton = new JButton();
  ButtonGroup checkBoxes = new ButtonGroup();
  ImageIcon openImage;
  ImageIcon run;
  ImageIcon flush;
  JPanel jPanel2 = new JPanel();
  JPanel jPanel3 = new JPanel();
  JPanel jPanel4 = new JPanel();
  JPanel jPanel5 = new JPanel();
  BorderLayout borderLayout2 = new BorderLayout();
  BorderLayout borderLayout3 = new BorderLayout();
  BorderLayout borderLayout4 = new BorderLayout();
  BorderLayout borderLayout5 = new BorderLayout();
  JButton flushButton = new JButton();

  //Construct the frame
  public SimulFrame() {
    enableEvents(AWTEvent.WINDOW_EVENT_MASK);
    try {
      jbInit();
    }
    catch(Exception e) {
      e.printStackTrace();
    }
  }

  //Component initialization
  private void jbInit() throws Exception  {
    openImage = new ImageIcon(SimulFrame.class.getResource("openFile.gif"));
    run = new ImageIcon(SimulFrame.class.getResource("run.gif"));
    flush = new ImageIcon(SimulFrame.class.getResource("flush.gif"));
    contentPane = (JPanel) this.getContentPane();
    contentPane.setLayout(borderLayout1);
    this.setSize(new Dimension(600, 400));
    this.setTitle("Simulation d'algos d'approximations");
    statusBar.setText(" ");
    runButton.setIcon(run);
    runButton.addActionListener(new java.awt.event.ActionListener() {

      public void actionPerformed(ActionEvent e) {
        runButton_actionPerformed(e);
      }
    });
    simulFromFile.setText("Fichier");
    simulFromFile.addItemListener(new java.awt.event.ItemListener() {

      public void itemStateChanged(ItemEvent e) {
        simulFromFile_itemStateChanged(e);
      }
    });
    jPanel1.setLayout(gridLayout1);
    gridLayout1.setColumns(2);
    gridLayout1.setRows(2);
    simulFromUser.setText("Manuel");
    simulFromUser.addItemListener(new java.awt.event.ItemListener() {

      public void itemStateChanged(ItemEvent e) {
        simulFromUser_itemStateChanged(e);
      }
    });
    jPanel2.setLayout(borderLayout2);
    jPanel4.setLayout(borderLayout3);
    jPanel5.setLayout(borderLayout4);
    jPanel3.setLayout(borderLayout5);
    flushButton.setToolTipText("");
    flushButton.setIcon(flush);
    flushButton.addActionListener(new java.awt.event.ActionListener() {

      public void actionPerformed(ActionEvent e) {
        flushButton_actionPerformed(e);
      }
    });
    openFileButton.addActionListener(new java.awt.event.ActionListener() {

      public void actionPerformed(ActionEvent e) {
        openFileButton_actionPerformed(e);
      }
    });
    jTextArea1.setEditable(false);
    jTextArea2.setEditable(false);
    jTextArea3.setEditable(false);
    jTextArea4.setEditable(false);
    openFileButton.setEnabled(false);
    nomFichier.setEnabled(false);
    enableLZ78.setMargin(new Insets(0, 2, 0, 2));
    enableLZ78.setPreferredSize(new Dimension(93, 17));
    enableLZ78.setSelected(true);
    enableLZ78.setMnemonic('0');
    enableLZ78.setText("Algorithme LZ78");
    enableLZ78.setForeground(new Color(102, 102, 153));
    enableLZ78.setHorizontalAlignment(SwingConstants.CENTER);

    enableBISECTION.setMargin(new Insets(0, 2, 0, 2));
    enableBISECTION.setPreferredSize(new Dimension(93, 17));
    enableBISECTION.setSelected(true);
    enableBISECTION.setMnemonic('0');
    enableBISECTION.setText("Algorithme BISECTION");
    enableBISECTION.setForeground(new Color(102, 102, 153));
    enableBISECTION.setHorizontalAlignment(SwingConstants.CENTER);

    enableSEQUENTIAL.setMargin(new Insets(0, 2, 0, 2));
    enableSEQUENTIAL.setPreferredSize(new Dimension(93, 17));
    enableSEQUENTIAL.setSelected(true);
    enableSEQUENTIAL.setMnemonic('0');
    enableSEQUENTIAL.setText("Algorithme SEQUENTIAL");
    enableSEQUENTIAL.setForeground(new Color(102, 102, 153));
    enableSEQUENTIAL.setHorizontalAlignment(SwingConstants.CENTER);

    enableGREEDY.setMargin(new Insets(0, 2, 0, 2));
    enableGREEDY.setPreferredSize(new Dimension(93, 17));
    enableGREEDY.setSelected(true);
    enableGREEDY.setMnemonic('0');
    enableGREEDY.setText("Algorithme GREEDY");
    enableGREEDY.setForeground(new Color(102, 102, 153));
    enableGREEDY.setHorizontalAlignment(SwingConstants.CENTER);

    checkBoxes.add(simulFromUser);
    checkBoxes.add(simulFromFile);
    simulFromUser.setSelected(true);
    openFileButton.setIcon(openImage);
    openFileButton.setMaximumSize(new Dimension(24, 24));
    openFileButton.setMinimumSize(new Dimension(24, 24));
    openFileButton.setIcon(openImage);
    openFileButton.setMnemonic('0');
    nomFichier.setText("Aucun");
    contentPane.add(statusBar, BorderLayout.SOUTH);
    contentPane.add(jToolBar1, BorderLayout.NORTH);
    jToolBar1.add(simulFromFile, null);
    jToolBar1.add(openFileButton, null);
    jToolBar1.addSeparator(new Dimension(10,10));
    jToolBar1.add(nomFichier, null);
    jToolBar1.addSeparator(new Dimension(20,10));
    jToolBar1.add(simulFromUser, null);
    jToolBar1.add(userInput, null);
    jToolBar1.addSeparator(new Dimension(20,10));
    jToolBar1.add(runButton, null);
    jToolBar1.addSeparator(new Dimension(20,10));
    jToolBar1.add(flushButton, null);
    contentPane.add(jPanel1, BorderLayout.CENTER);


    jPanel1.add(jPanel2, null);
    jPanel1.add(jPanel3, null);
    jPanel1.add(jPanel4, null);
    jPanel1.add(jPanel5, null);

    jScrollPane1.getViewport().add(jTextArea1, null);
    jScrollPane2.getViewport().add(jTextArea2, null);
    jScrollPane3.getViewport().add(jTextArea3, null);
    jScrollPane4.getViewport().add(jTextArea4, null);

    jPanel2.add(jScrollPane1,BorderLayout.CENTER);
    jPanel2.add(enableLZ78, BorderLayout.NORTH);
    jPanel3.add(jScrollPane2,BorderLayout.CENTER);
    jPanel3.add(enableBISECTION, BorderLayout.NORTH);
    jPanel4.add(jScrollPane3,BorderLayout.CENTER);
    jPanel4.add(enableSEQUENTIAL, BorderLayout.NORTH);
    jPanel5.add(jScrollPane4,BorderLayout.CENTER);
    jPanel5.add(enableGREEDY, BorderLayout.NORTH);

    Config.LZ78_out = new JTextAreaPrintStream(jTextArea1);
    Config.BISECTION_out = new JTextAreaPrintStream(jTextArea2);
    Config.SEQUENTIAL_out = new JTextAreaPrintStream(jTextArea3);
    Config.GREEDY_out = new JTextAreaPrintStream(jTextArea4);
  }

  //File | Exit action performed
  public void fileExit_actionPerformed(ActionEvent e) {
    System.exit(0);
  }

  //Help | About action performed

  //Overridden so we can exit when window is closed
  protected void processWindowEvent(WindowEvent e) {
    super.processWindowEvent(e);
    if (e.getID() == WindowEvent.WINDOW_CLOSING) {
      fileExit_actionPerformed(null);
    }
  }

  void flushButton_actionPerformed(ActionEvent e) {
    jTextArea1.setText("");
    jTextArea2.setText("");
    jTextArea3.setText("");
    jTextArea4.setText("");
  }

  public static String read(Reader reader) throws IOException
  {
      boolean over = false;
      String _content = "";
      int bufferSize = 1024;
      char[] buffer = new char[bufferSize];
      while(!over)
      {
        int r = reader.read(buffer);
        if (r!=-1)
        {
          String tmp = String.valueOf(buffer,0,r);
          _content = _content + tmp;
        }
        if (r<bufferSize) over = true;
      }
      return _content;
  }

  void runButton_actionPerformed(ActionEvent e) {
    if(simulFromUser.isSelected())
    {
      String sr = userInput.getText();
      if (enableLZ78.isSelected())  Config.LZ78_out.println(LZ78.compress(sr).toString(true));
      if (enableBISECTION.isSelected()) Config.BISECTION_out.println(Bisection.compress(sr).toString(true));
      if (enableSEQUENTIAL.isSelected()) Config.SEQUENTIAL_out.println(Sequential.compress(sr).toString(true));
      if (enableGREEDY.isSelected()) Config.GREEDY_out.println(Greedy.compress(sr).toString(true));
    }
    if(simulFromFile.isSelected())
    {
      try
      {
        String sr = read(new FileReader(cheminFichier));
        if (enableLZ78.isSelected())
        {
            Config.LZ78_out.println(LZ78.compress(sr).toString(true));
        }
        if (enableBISECTION.isSelected())
        {
            Config.BISECTION_out.println(Bisection.compress(sr).toString(true));
        }
        if (enableSEQUENTIAL.isSelected())
        {
            Config.SEQUENTIAL_out.println(Sequential.compress(sr).toString(true));
        }
        if (enableGREEDY.isSelected())
        {
            Config.GREEDY_out.println(Greedy.compress(sr).toString(true));
        }
      }
      catch(FileNotFoundException e2)
      { JOptionPane.showMessageDialog(jToolBar1,"Fichier \""+nomFichier.getText()+"\" introuvable !","Erreur",JOptionPane.WARNING_MESSAGE);  }
      catch(IOException e2)
      { JOptionPane.showMessageDialog(jToolBar1,"Erreur signale sur un priphrique I/O !","Erreur",JOptionPane.WARNING_MESSAGE);  }
    }
  }

  String cheminFichier = "None";
  JCheckBox enableLZ78 = new JCheckBox();
  JCheckBox enableBISECTION = new JCheckBox();
  JCheckBox enableSEQUENTIAL = new JCheckBox();
  JCheckBox enableGREEDY = new JCheckBox();

  void openFileButton_actionPerformed(ActionEvent e) {
    JFileChooser chooser = new JFileChooser();
    int returnVal = chooser.showOpenDialog(this);
    if(returnVal == JFileChooser.APPROVE_OPTION)
    {
      nomFichier.setText(chooser.getSelectedFile().getName());
      cheminFichier = chooser.getSelectedFile().getAbsolutePath();
    }
  }

  void simulFromFile_itemStateChanged(ItemEvent e)
  {
    if (e.getStateChange()==e.DESELECTED)
    {
      openFileButton.setEnabled(false);
      nomFichier.setEnabled(false);
    }
    if (e.getStateChange()==e.SELECTED)
    {
      openFileButton.setEnabled(true);
      nomFichier.setEnabled(true);
    }
  }

  void simulFromUser_itemStateChanged(ItemEvent e)
  {
    if (e.getStateChange()==e.DESELECTED)
    {
      userInput.setEnabled(false);
    }
    if (e.getStateChange()==e.SELECTED)
    {
      userInput.setEnabled(true);
    }
  }
}